#!/usr/bin/perl

## use strict;
## use warnings;
use DBI;
use IO::Socket;
use Sys::Syslog qw(:DEFAULT setlogsock);
# para cyrus sobra maildirsize

our $syslog_socktype = 'unix'; # inet, unix, stream, console
our $syslog_facility="mail";
our $syslog_options="pid";
our $syslog_priority="info";
our %attr = ();
our $option;
our $recipol;
our $action;
our $lokhaykhacer;
our $instanmemo;
our $respuesta = "";
our $conexion = "";
our $verbose=0;
###################################### CONFIGURATION VARIABLES ################################################
our $mysql_server = "xxx.xxx.xxx.xxx";
our $mysql_port = 3306;
our $database = "qreject";
our $usu_mysql = "xxxxxxxxxxx";
our $clave_mysql = "xxxxxxxxxxxxxxx";
###############################################################################################################




sub smtpd_access_policy_recipientes {
	my $instanciamomen = $attr{"instance"};
	if ($instanmemo eq $instanciamomen) 
			{
				my $actual = lc $attr{"recipient"};
		       		$recipol = $recipol."$actual,";
			}	
        		else
			{
	   			$instanmemo = $attr{"instance"};
				$recipol = "";
				my $actual = $attr{"recipient"};
                                $recipol = $recipol."$actual,";
			}
 syslog $syslog_priority, "Mailboxes to check : $recipol" if ($verbose==1 || $verbose==2); 
 return "dunno\n\n";
}


sub smtpd_access_policy_quota {
    my $instquota  = $attr{"instance"};
    if ($instquota ne $instanmemo) 
                     {
                     $recipol = "";
                     }       
    my @arrayderecipientes=split(/,/,$recipol);
    my $recimensaje = " ";
    my $recipiente;
    my $dsn02 = "DBI:mysql:database=$database;host=$mysql_server;port=$mysql_port";
    my $user02 = $usu_mysql;
    my $pass02 = $clave_mysql;
    my $dbh02 = DBI->connect($dsn02, $user02, $pass02) or die "Cant connect to the DB: $DBI::errstr\n";
    foreach $recipiente (@arrayderecipientes)
    	{
     	   	my $respuesta="";
		my $maquinaaconectar=" ";	
		my $recipienteq = $dbh02->quote( $recipiente );
		my $consulta02= "select buzon,maquina from dirbuzon where direccion="."$recipienteq";
             	syslog $syslog_priority, "Quoted recipient : $recipienteq" if ($verbose==2);
		my $sth02 = $dbh02->prepare("$consulta02");
		$sth02->execute();
		my @data = $sth02->fetchrow_array;
		$sth02->finish(); 			
		my $rutasacomprobar=$data[0];
		$maquinaaconectar=$data[1];
	       	my $sizepolitica = $attr{"size"}/1024; 
		syslog $syslog_priority, "Mailbox daemon to conect ip is  : $maquinaaconectar" if ($verbose==2);

##  Modifying array for obtaining an array with only real mailboxes and not aliases

		if ($maquinaaconectar eq "*")
		{		
		     syslog $syslog_priority, "Mailbox daemon to conect ip is : $maquinaaconectar" if ($verbose==2);	
##  Connecting to mailboxes daemon
		     my $buclar=2;
		     my $indice=0;	
		     my $aliasquetoca="";
		     my $aliasquetocaq="";
		     my $antibucles=0;				
		     my @recipnormalizar=split(/,/,$rutasacomprobar);
		     my @nuevosmeter;		
		     syslog $syslog_priority, "Entering to conversion loop with : @recipnormalizar" if ($verbose==2);	
		     while (($buclar != 0) && ($antibucles < 10)) 
			{
				$buclar=0;
				$indice=0;
				syslog $syslog_priority, "Starting again" if ($verbose==2);
				syslog $syslog_priority, "Entering to loop with : @recipnormalizar" if ($verbose==2);
				foreach $aliasquetoca (@recipnormalizar)
    				{
					syslog $syslog_priority, "Too many elements in the array, probably alias bad defined" if ($indice >=100);
					$respuesta="A" if ($indice >= 100);
					$antibucles=200 if ($indice >= 100);
					last if ($indice >= 100);
					syslog $syslog_priority, "Index value at the beggining is : $indice" if ($verbose==2);
					my $aliasquetocaq = $dbh02->quote( $aliasquetoca );
					my $consulta03= "select buzon,maquina from dirbuzon where direccion="."$aliasquetocaq";
                			syslog $syslog_priority, "Quoted recipient number $indice : $aliasquetoca" if ($verbose==2);
					my $sth03 = $dbh02->prepare("$consulta03");
					$sth03->execute();
					my @data02 = $sth03->fetchrow_array;
					$sth03->finish(); 			
					my $rutasacomprobarb=$data02[0];
					my $maquinaaconectarb=$data02[1];
					if ($maquinaaconectarb eq "*")
					{
					syslog $syslog_priority, "On the splice : $aliasquetoca" if ($verbose==2);
					my $loquequito=splice(@recipnormalizar, $indice, 1);
					syslog $syslog_priority, "Removing from array : $loquequito" if ($verbose==2);
					## splice(@recipnormalizar, $indice, 1); \@recipnormalizar;
					delete $recipnormalizar[$indice];
					my @nuevosmeter=split(/,/,$rutasacomprobarb);
					syslog $syslog_priority, "Saving into the array : @nuevosmeter" if ($verbose==2);		
					push (@recipnormalizar, @nuevosmeter);
					syslog $syslog_priority, "Processed array contains  : @recipnormalizar" if ($verbose==2);		
					$buclar=22;
					}
					else
					{
					syslog $syslog_priority, "Increasing array index" if ($verbose==2);			
					$indice=$indice + 1;
					}
				}
				$antibucles=$antibucles + 1;
				syslog $syslog_priority, "Antibucles is : $antibucles" if ($verbose==2);
				syslog $syslog_priority, "Buclar is : ***$buclar***" if ($verbose==2);
				syslog $syslog_priority, "Index is : $indice" if ($verbose==2);
				syslog $syslog_priority, "Proccessing array now contains : @recipnormalizar" if ($verbose==2);
			}
		$aliasquetoca=" ";
		$aliasquetocaq=" ";
		syslog $syslog_priority, "Proccesed array exists with : @recipnormalizar" if ($verbose==1);

## Proccessing now obtained array
		if ($indice < 100)
		{
		foreach $aliasquetoca (@recipnormalizar)
    		   {
			$aliasquetocaq = $dbh02->quote( $aliasquetoca );
			my $maquinaaconectarb=" ";
			syslog $syslog_priority, "Quoted recipient : $aliasquetocaq" if ($verbose==2);
			my $consulta03= "select buzon,maquina from dirbuzon where direccion="."$aliasquetocaq";
			my $sth03 = $dbh02->prepare("$consulta03");
			$sth03->execute();
			my @data02 = $sth03->fetchrow_array;
			$sth03->finish(); 			
			my $rutasacomprobarb=$data02[0];
			$maquinaaconectarb=$data02[1];
			if (($maquinaaconectarb eq "") || ($maquinaaconectarb eq "*"))
			{
				$respuesta="A";
				syslog $syslog_priority, "The recipient $aliasquetoca coming from alias $recipiente could not be proccessed...";
			}
			else
			{
				$conexion=0;
				my $remote = IO::Socket::INET->new( Proto     => "tcp",
                                        PeerAddr  => $maquinaaconectarb,
                                        PeerPort  => "3333",
                                       );
        			unless ($remote) { syslog $syslog_priority, "Can't connect to $maquinaaconectarb" };
       				unless ($remote) { $respuesta="A" };
				unless ($remote) { $conexion=1 };
				if ($conexion==0)
				{      			
					$remote->autoflush(1);	
					print $remote "rutas=$rutasacomprobarb\nsize=$sizepolitica\nrequest=smtpd_access_policy\n\n";
			   		while ( <$remote> ) 
			   		{ 
			    		$respuesta=$_;
			    		chop $respuesta;
			    		syslog $syslog_priority, "Got answer : ***$respuesta***" if ($verbose==1 || $verbose==2);
			    		last if ($respuesta eq "R");
			    		last if ($respuesta eq "A");
					}	
					syslog $syslog_priority, "EXITING FROM LOOP" if ($verbose ==2);
					close $remote;
				}									
			}
		
			if ($respuesta eq "R")
                	{
                   		if ($recimensaje =~ /$recipiente/)
                   		{
                   		$recimensaje = $recimensaje;
                   		}
                   		else
                   		{
                   		$recimensaje = $recimensaje."$recipiente, ";
                   		}
				last;
                	}
		     }	
		   }
		}
		else
#  END of if for dealing with aliases
		{
			if ($maquinaaconectar eq "")
			{
				$respuesta="A";
	                        syslog $syslog_priority, "The recipient $recipiente could not be proccessed...";
			}
			else
			{
				$conexion=0;
				my $remote02 = IO::Socket::INET->new( Proto     => "tcp",
                                        PeerAddr  => $maquinaaconectar,
                                        PeerPort  => "3333",
                                       );
        	    unless ($remote02) { syslog $syslog_priority, "Can't connect to $maquinaaconectar" };						        				
				unless ($remote02) { $respuesta="A" };
				unless ($remote02) { $conexion=1 };
				if ($conexion==0)
				{      			
					$remote02->autoflush(1);	
					print $remote02 "rutas=$rutasacomprobar\nsize=$sizepolitica\nrequest=smtpd_access_policy\n\n";
			   		while ( <$remote02> ) 
			   		{ 
			    		$respuesta=$_;
			    		chop $respuesta;
			    		syslog $syslog_priority, "Obtained answer : ***$respuesta***" if ($verbose==1 || $verbose==2);
			    		last if ($respuesta eq "R");
			    		last if ($respuesta eq "A");
					}	
					syslog $syslog_priority, "EXITING FROM LOOP" if ($verbose==2);
					close $remote02;
				}									

		        }		
		if ($respuesta eq "R")
                {
                   if ($recimensaje =~ /$recipiente/)
                   {
                   $recimensaje = $recimensaje;
                   }
                   else
                   {
                   $recimensaje = $recimensaje."$recipiente, ";
                   }
                }
	     }					
	}


## Lets see what do we answer to Postfix
	$dbh02->disconnect;
	$recipol = "";

	if ($recimensaje eq " ") 
	{
		return "dunno\n\n";
	}	
        else
	{
		return "reject is-are overquota : $recimensaje\n\n";
	}

}


sub fatal_exit {
    my($first) = shift(@_);
    syslog "err", "fatal: $first", @_;
    exit 1;
}

setlogsock $syslog_socktype;
openlog $0, $syslog_options, $syslog_facility;

while ($option = shift(@ARGV)) {
    if ($option eq "-v") {
	$verbose = 1;
    } elsif ($option eq "-vv") {
	$verbose = 2;
    }
      else 
    {
	syslog $syslog_priority, "Invalid option: %s. Usage: %s [-v] or [-vv]",
		$option, $0;
	exit 1;
    }
}

select((select(STDOUT), $| = 1)[0]);

while (<STDIN>) {
    if (/([^=]+)=(.*)\n/) {
	$attr{substr($1, 0, 512)} = substr($2, 0, 512);
      } elsif ($_ eq "\n") {
	if ($verbose==1 || $verbose==2) {
	    for (keys %attr) {
		             syslog $syslog_priority, "Attribute: %s=%s", $_, $attr{$_};
			     }
	}
	fatal_exit "unrecognized request type: '%s'", $attr{request}
	    unless $attr{"request"} eq "smtpd_access_policy";
	$lokhaykhacer = $attr{"protocol_state"};
	if ($lokhaykhacer eq "RCPT") 
			{
		       		$action = smtpd_access_policy_recipientes();
			}	
        if ($lokhaykhacer eq "END-OF-MESSAGE")
			{
	   			$action = smtpd_access_policy_quota();
			}
	syslog $syslog_priority, "Action from Postfix-Quota-Reject mail scanning machine policy : %s", $action;
	print STDOUT "action=$action";
	%attr = ();
    } else {
	chop;
	syslog $syslog_priority, "warning: ignoring garbage: %.100s", $_;
    }
}
